/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////// Comments ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
Release Version:

1.0    -  Late May  2003(05/xx/03) : Initial Release.
1.3.1  -  Sept 17th 2003(09/17/03) : Fixed various bugs.
1.5    -  Sept 26th 2003(09/26/03) : Fix of Sept Patch(Suicide no longer results in NPK status).
1.5.1  -  Sept 28th 2003(09/28/03) : Now walks into the courtyard before asking to die.
1.5.2  -  Sept 28th 2003(09/28/03) : More house recall checks. More chest checking.
1.5.3  -  Oct  1st  2003(10/01/03) : Fixed navigation problem
1.5.4  -  Oct  4th  2003(10/04/03) : Added PlatsPerDay stats. More Apartment door fixes.
1.6    -  Oct  4th  2003(10/04/03) : *Otimization* Added corpse looting.
1.6.1  -  Oct  12th 2003(10/12/03) : No longer times out if henchman is unavailable.
1.7    -  Oct  14th 2003(10/14/03) : Gives plats to henchman if total is over 50.
1.7.5  -  Nov  7th  2003(11/07/03) : More chest checking! No more AC idle timer if Idler.dll is included.
1.8    -  Nov  24th 2003(11/24/03) : Static chest checking. Can start with either Total or Half at chest.
1.8.1  -  Nov  28th 2003(11/28/03) : Can start with Total at mansion.
1.8.2  -  Dec  1st  2003(12/01/03) : Fix for mansion start up.
1.8.5  -  Dec  21st 2003(12/21/03) : Anti-Idle actually works now!
1.8.6  -  Feb  21th 2004(02/21/04) : Work arounds for decal/skunkworks. skapi.fPointerBusy -> fPointerBusy(). OnTell -> OnTellMisc
1.8.7  -  May  15th 2004(05/15/04) : Fix for May patch. "Plain Healing Kit" became "Adept Healing Kit", "Stamina Elixir" -> "Stamina Tincture". Prices adjusted. "Health Potion" Weight adjusted
2.0.0  -  Dec  15th 2004(12/15/04) : Initial Public Release (I just wanted to finally be able to say it is version 2.0.0)

*/

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////// Global Variables ///////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

////////////////////////Change these values for limits on healing and when to drink stamina elixirs
//////////////////////////////////////////////////////////////////////////////////////////
var HealthThreshold = 75;
var MaxHealth = 110;
var StaminaThreshold = 50;
var MaxStamina = 110;
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
var h = new myHandlers();

var xroute = Xnav.XrouteNew();

var VersionNo = "2.0.0 Released 12.15.2004";

var EyeDropper = skapi.AcoFindInInv("Eye Dropper");
var Alembic = skapi.AcoFindInInv("Alembic");
var HealKitTotal = skapi.CitemOfKindInInv("Adept Healing Kit");
var PeaTotal = skapi.CitemOfKindInInv("Realgar Pea");
var DraughtTotal = skapi.CitemOfKindInInv("Health Draught");
var VictualTotal = skapi.CitemOfKindInInv("Victual Infusion");
var HealKit = skapi.AcoFindInInv("Adept Healing Kit");
var Pea = skapi.AcoFindInInv("Realgar Pea");
var Draught = skapi.AcoFindInInv("Health Draught");
var Victual = skapi.AcoFindInInv("Victual Infusion");
var ConcVictualTotal = skapi.CitemOfKindInInv("Concentrated Victual Infusion");
var ConcVictual = skapi.AcoFindInInv("Concentrated Victual Infusion");
var PotionTotal = skapi.CitemOfKindInInv("Potion of Healing");
var Potion = skapi.AcoFindInInv("Potion of Healing");
var StamTincture = skapi.AcoFindInInv("Stamina Tincture");
var StamTinctureTotal = skapi.CitemOfKindInInv("Stamina Tincture");
var PlatsTotal = 0;
var merch = skapi.AcoFromSz("Brisin the Healer");
var mage = skapi.AcoFromSz("Sialla Jiro");
var char = skapi.szName;

var buff = "buffself";           //Set to "buffbot" to have a bot buff you.
var buffbotname = "Maki Izumi";        //Name of the buffbot
var buffbotmessage = "alltrade";    //Command to tell buffbot
var buffbotlastspell = "Boon of Refinement";    //Set to the last spell the bot casts on you 
var buffchain = false;           //Set to true to do chain buffs

var autothreshold = true;        //Set to true if you want the macro to automaticly set thresholds

var useworkplace = false;           //Set to true to move to workplace
//var worklat = "11.100"; //These don't seem to be working, go to fgetcurloc() if you want to edit these
//var worklng = "58.600";

var RestartScript = false;

var Henchman = "Chrestomanci"
var AuthorizationCode = "o52beta";
var distance_Chest = 0.025

var totalTab= 0;
var szEditMsg;
var MyLoc;
var MyLat;
var MyLng;
var Hours = 0;
var Mins = 0;
var Seconds = 0;
var tempSec;
var tempMin;
var Clap = 0;
var ClapPerMin;
var CompCosts = 0;
var tempMins;
var tempHour;
var TotalPyrealsMade;
var TotalPotions = 0;
var PlatProgress;
var PlatsPerHour;
var PlatsPerDay;
var PlatsAtStart;
var PyrealStart;
var PyrealNow;
var PyrealHour;
var PyrealTotal;
var PyrealPerClap;
var PlatsNow;
var RetreatPortal;
//MyLoc = skapi.acoChar.maploc;
//MyLat = MyLoc.lat.toFixed(2);
//MyLng = MyLoc.lng.toFixed(2);
var Loop = 0;
var gamestate;
var makepotion = 1;
var needitem = 2;
var pause = 3;
var currentlocation;
var vendorstate = null;
var chatwin;
var bufftimer;
var logtimer;
var acfbot;
var coacobot;
var itemaco;
var itemvendor;
var donebuffing;
var acfdrop;
var coaco_SlotClapper;
var playerkiller;
var Vendor = null;
//var itemAssess = null;
var slotclapper;
var slotrunner;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////// ACF Variables //////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
var acf_Chest = skapi.AcfNew();
acf_Chest.szName = "Storage";
acf_Chest.oty = otyContainer;
var coaco_Chest;
var aco_Chest;
var oid_Chest;

var acf_Pack = skapi.AcfNew();
acf_Pack.szName = "Pack";
acf_Pack.oty = otyContainer;
acf_Pack.olc = olcContained;
var coaco_Pack;
var aco_Pack;

var acf_Item = skapi.AcfNew();
acf_Item.olc = olcContained;
var coaco_Item;
var aco_Item;
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////// PROGRESS ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
function Timer() {
   Seconds = (timer.cmsec/1000 - (Hours * 3600 + Mins * 60)).toFixed(0);
   while(Seconds >= 60) {
      Seconds = Seconds - 60;
      Mins++;
   }
   while(Mins >= 60) {
      Mins = Mins - 60; 
      Hours++;
   }
}

function Progress() {
   //PlatsNow = skapi.CitemOfKindInInv("Platinum Scarab");
   //PyrealNow = skapi.cpyCash;
   Timer();
   PlatProgress = (PlatsTotal).toFixed(2);
   PlatsPerHour = (PlatProgress / (timer.cmsec / 3600000)).toFixed(2);
   PlatsPerDay = (PlatsPerHour * 24).toFixed(2);
   PyrealsPerHour = (PlatsPerHour * 44000).toFixed(2);
   MsPerHour = (PyrealsPerHour / 100000).toFixed(2);
}

/*
function Progress() {
   PlatsNow = skapi.CitemOfKindInInv("Platinum Scarab");
   PyrealNow = skapi.cpyCash;
   Timer();
   PlatProgress = (PlatsNow + ((skapi.cpyCash - PyrealStart) / 44000) - PlatsAtStart);
   PlatProgress = PlatProgress.toFixed(2);
   PlatsPerHour = (PlatProgress / (timer.cmsec / 3600000));
   PlatsPerHour = PlatsPerHour.toFixed(2);
   PyrealsPerHour = (PlatsPerHour * 44000);
   MsPerHour = (PyrealsPerHour / 100000);
   MsPerHour = MsPerHour.toFixed(2);
}
*/

/*
function ClapCounter()  {
   Clap++
   Timer();
   if(Mins > 0){
      ClapPerMin = Clap/(Mins + Hours * 60);
   }
   else {
      ClapPerMin = Clap;
   }
//   szEditMsg = ClapPerMin.toFixed(2)+ " Clap/Min"
// skapi.SetControlProperty(szPanelName, "editMsg7", "Text", szEditMsg);
   TotalPyrealsMade = ((TotalPotions * 450)-CompCosts);
// szEditMsg = "Total Pyreals Made: "+TotalPyrealsMade;
// skapi.SetControlProperty(szPanelName, "editMsg9", "Text", szEditMsg);
   PyrealPerClap = (TotalPyrealsMade/Clap);
// szEditMsg = "Pyreals Per Clap: "+PyrealPerClap.toFixed(2);
// skapi.SetControlProperty(szPanelName, "editMsg8", "Text", szEditMsg);
}
*/

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////// MISCELLANEOUS ///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

function fPointerBusy() //Code included for the Jan Patch. Should not be needed for long.
   {
   var pdw = skapi.PdwMemlocFromSz("PointerImage");
   var dw = skapi.DwReadMemloc(pdw + 4);
   return dw == 0x14;
   }
   
function Autothreshold() {
   if(autothreshold == true) {
      var healthtemp = skapi.SkinfoFromVital(vitalHealthMax);
      HealthThreshold = ((healthtemp.lvlCur / 2) + 40);
      HealthMax = (healthtemp.lvlCur - 40);
      var staminatemp = skapi.SkinfoFromVital(vitalStaminaMax);
      StaminaThreshold = (staminatemp.lvlCur / 2);
      StaminaMax = (staminatemp.lvlCur - 65);
      skapi.outputline("HealthThreshold is " +HealthThreshold+ ", HealthMax is " +HealthMax);
      skapi.outputline("StaminaThreshold is " +StaminaThreshold+ ", StmainaMax is " +StaminaMax);
   }
}   

function Buff() {
   donebuffing = false
   if(buff == "buffself") {
      // nb code here
   }
   if(buff == "buffbot") {
      skapi.outputline("Recalling to allegiance mansion for some buffs from the neighborhood buffbot");
      say("@House Mansion_Recall");
      skapi.WaitEvent(60000, wemSpecific, evidOnEndPortalSelf);
      skapi.WaitEvent(5000,3);
      acfbot = skapi.AcfNew();
      acfbot.szName = buffbotname;
      acfbot.distMax = 0.3;
      coacobot = acfbot.CoacoGet();
      if(coacobot.Count == 1) {
         skapi.Tell(buffbotname,"Strength");
         delay(1000);
         skapi.Tell(buffbotname,"Endurance");
         delay(1000);
         skapi.Tell(buffbotname,"Healing");
         delay(1000);
         if(buffchain == true) {
            skapi.Tell(buffbotname,"Chain");
            delay(1000);
         }
         skapi.Tell(buffbotname,buffbotmessage);
         while(!donebuffing) {
            skapi.WaitEvent(390000, wemSpecific, evidOnSpellAdd);
            if(bufftimer.cmsec >= 3900000) break;
         }
         skapi.OutputLine("WOOT I GOT BUFFED");
      }else{
         skapi.OutputLine(buffbotname+ " isn't here. Oh well, i'll try again in an hour"); 
      }    
   }
   fgetcurloc();
}

function say(message) {
   if(!skapi.fInChatBuffer) 
   skapi.Keys("{return}");
   skapi.Sleep(250);//skapi.WaitEvent(250,3);
   skapi.PasteSz(message);
   skapi.Sleep(250);//skapi.WaitEvent(250,3);
   skapi.Keys("{return}");
}

function delay(time) {
   skapi.WaitEvent(time,wemFullTimeout);
}

function relog(slotno) {
   skapi.OutputLine("Logging on to "+slotno); 
   skapi.WaitEvent(0);
   while(skapi.plig == pligInWorld) {
      skapi.Keys("~{esc}"); //skapi.Logout();
      skapi.WaitEvent(60000,wemSpecific,evidOnEnd3D);
      delay(15000);
   }
   do {
      skapi.MouseMove(130, 145 + 15 * slotno);
      skapi.MouseButton(ibuttonLeft);
      skapi.MouseMove(300,180); // Click Enter World
      skapi.MouseButton(ibuttonLeft);
      skapi.WaitEvent(240000, wemSpecific, evidOnEndPortalSelf);
      delay(10000);
   } while(skapi.plig == pligAtLogin);
   skapi.MouseMove(-318,-90);      //706,678
   skapi.MouseButton(ibuttonLeft); //Chat Maximize
   skapi.WaitEvent(150,3);
   skapi.Keys(cmidFirstPersonView);
   skapi.WaitEvent(150,3);
   for(var i=0; i<10; i++) {
      skapi.Keys(cmidCameraLower);
      skapi.WaitEvent(200,3);
   }
}

function restart() {
   Progress();
   skapi.OutputLine("Run Time: "+Hours+" Hours "+Mins+ " Mins "+Seconds+" Seconds. Logging now!");
   //gamestate = pause;
   delay(5000);
   while(skapi.plig != pligNotRunning) {
      skapi.Keys("@{f4}");
      delay(60000);
   }
   while(skapi.plig == pligNotRunning) {
      skapi.ClickLobbyPlay()
      delay(60000);
   }
   while(skapi.plig == pligAtLogin) {
      skapi.MouseMove(300,180); // Click Enter World
      skapi.MouseButton(ibuttonLeft);
      skapi.WaitEvent(240000, wemSpecific, evidOnEndPortalSelf);
      delay(10000);
   }
   skapi.MouseMove(-318,-90);      //706,678
   skapi.MouseButton(ibuttonLeft); //Chat Maximize
   skapi.WaitEvent(150,3);
   skapi.Keys(cmidFirstPersonView);
   skapi.WaitEvent(150,3);
   for(var i=0; i<10; i++) {
      skapi.Keys(cmidCameraLower);
      skapi.WaitEvent(200,3);
   }
} 

function suicide() {
   skapi.OutputLine("Starting Suicide Function");
   if(skapi.szName.match(/Total/)) {
      while(!(skapi.acoChar.oty & otyPK)) {
         skapi.OutputLine("I'm NPK");
         delay(1000);
      }
      skapi.OutputLine("I'm PK");
      do {
         Pauser.Clear();
         skapi.OutputLine("while(skapi.acoChar.oty & otyPK);");
         do {
            skapi.OutputLine("while(currentlocation != Slaughter House);");
            say("@House Alleg_Recall");
            skapi.WaitEvent(90000, wemSpecific, evidOnEndPortalSelf);
            delay(5000);
            fgetcurloc();
         } while(currentlocation != "Slaughter House");
         Pauser.Clear();
         xroute.FromFile("Green-Mile.xroute", false);
         e = ErrRunXroute(xroute);
         if (e) {
            skapi.OutputLine("Error caught: "+e);
            Pauser.Clear();
            continue;
         }
         Pauser.Clear();
         lootcorpse();
         giveitem("Platinum Scarab",Henchman);

         skapi.Tell(Henchman, AuthorizationCode);//skapi.szName+" is sending a death request. Authorization Code: "+AuthorizationCode)
         skapi.WaitEvent(90000, wemSpecific, evidOnEndPortalSelf);
      } while(skapi.acoChar.oty & otyPK);
   }else{
      skapi.OutputLine("I'm on the wrong character!");
      console.StopScript();
   }
}

function lootcorpse() {   
   var acf_Corpse = skapi.AcfNew();
   acf_Corpse.szName = "Corpse of "+skapi.szName;
   acf_Corpse.ocm = ocmPlayerCorpse;
   acf_Corpse.distMax = .07;
   var coaco_Corpse;
   var aco_Corpse;
   coaco_Corpse = acf_Corpse.CoacoGet();
   skapi.OutputLine(acf_Corpse.szName);
   skapi.OutputLine(coaco_Corpse.Count);
   if(coaco_Corpse) {
      skapi.OutputLine("if(coaco_Corpse) {");
      for(var i=0;i<coaco_Corpse.Count;i++) {
         skapi.OutputLine("for(var i;i<coaco_Corpse.Count;i++) {"+i);
         aco_Corpse = coaco_Corpse.Item(i);
         
         do {
            skapi.OutputLine("Assessing Corpse");
            skapi.AssessAco(aco_Corpse);
            skapi.WaitEvent(1000, wemSpecific, evidOnAssessItem);
         } while(!aco_Corpse.oai); //while(skapi.WaitEvent(3000, wemSpecific, evidOnAssessItem) == evidOnAssessItem);
         skapi.OutputLine("Corpse is "+((aco_Corpse.oai.ibi.fOpen) ? "open" : "closed"));
         while(!aco_Corpse.oai.ibi.fOpen) {
            aco_Corpse.Use();
            skapi.WaitEvent(5000, wemSpecific, evidOnOpenContainer);
            skapi.AssessAco(aco_Corpse);
            skapi.WaitEvent(3000, wemSpecific, evidOnAssessItem);
         }
         while(aco_Corpse.coacoContents.count > 0) {
            var aco_Item = aco_Corpse.coacoContents.Item(0);
            aco_Item.MoveToPack(0,0,true);
            while(fPointerBusy()) {delay(100);} //skapi.WaitEvent(5000, wemSpecific, evidOnAddToInventory);
            //delay(750);
            //var coaco_Item = acf_Item.CoacoGet();
         }
      }
   }
   skapi.OutputLine("function lootcorpse Finished");
}

function giveitem(giveItem,giveCharacter) {
   while(skapi.CitemOfKindInInv(giveItem) > 50) {
      skapi.AcoFindInInv(giveItem).MoveToStack(skapi.AcoFromSz(giveCharacter));
      skapi.WaitEvent(10000,wemSpecific,evidOnRemoveFromInventory);
   }
}

function startup() {
   fgetcurloc();
   if(skapi.szName.match(/Total/)) {
      skapi.OutputLine("current location:"+ currentlocation);
      if(currentlocation == "Slaughter House") {
                   do {
                      say("@House Recall");
                      skapi.WaitEvent(90000,wemSpecific,evidOnEndPortalSelf);
                      skapi.WaitEvent(0);
                      delay(5000);
                      fgetcurloc();
                      //skapi.OutputLine("skapi.acoChar.maploc.head = "+skapi.maplocCur.head);
                      //var heading = skapi.maplocCur.head;
                     // skapi.outputline("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
                   } while(skapi.maplocCur.dungid == 22112 || skapi.maplocCur.dungid == 0);
                   var acf_Door = skapi.AcfNew();
                   acf_Door.szName = "Door";
                   acf_Door.distMax = .03;
                   var coaco_Door = acf_Door.CoacoGet();
                   var aco_Door= coaco_Door.Item(0);     // Try to find object
                   skapi.OutputLine("Door ACO is "+aco_Door.oid);
                   var mloc= aco_Door.maploc;         // Get the location
                   var l=0;
                   do {
                      skapi.GoToMaploc(mloc,0.002,true); // Walk to door
                      skapi.WaitEvent(9000,wemSpecific,evidOnNavStop);
                      do {
                         skapi.OutputLine("Assessing Door");
                         skapi.AssessAco(aco_Door);
                         skapi.WaitEvent(1000, wemSpecific, evidOnAssessItem);
                      } while(!aco_Door.oai); //while(skapi.WaitEvent(3000, wemSpecific, evidOnAssessItem) == evidOnAssessItem);
                      skapi.OutputLine("Door is "+((aco_Door.oai.ibi.fOpen) ? "open" : "closed"));
                      while(!aco_Door.oai.ibi.fOpen) {
                         aco_Door.Use();
                         skapi.WaitEvent(5000, wemSpecific, evidOnOpenContainer);
                         skapi.AssessAco(aco_Door);
                         skapi.WaitEvent(3000, wemSpecific, evidOnAssessItem);
                      }
                      l++;
                      if(l>10) {
                         say("@House Recall");
                         skapi.WaitEvent(90000,wemSpecific,evidOnEndPortalSelf);
                         skapi.WaitEvent(0);
                         delay(5000);
                         l=0;
                      }
                   } while(skapi.maplocCur.Dist2DToMaploc(mloc)>0.002); // Repeat?
                   
                   MyLoc = skapi.maplocCur;
                   MyLat = MyLoc.lat.toFixed(3);
                   MyLng = MyLoc.lng.toFixed(3);
                   var heading = MyLoc.head;
                   var DoorLat = MyLat;
                   var DoorLng = MyLng;
                   ///////
                   if(heading >= 330 || heading <= 50) { //North 0
                      var DoorLat = MyLat - (-0.03);
                   }
                   ///////
                   if(heading >= 130 && heading <= 230) { //South 180
                      var DoorLat = MyLat - (0.03);
                   }
                   ////////
                   if(heading >= 60 && heading <= 120) { //East 90
                      var DoorLng = MyLng - (-0.03);
                   }
                   ////////
                   if(heading >= 240 && heading <= 320) { // West 270
                      var DoorLng = MyLng - (0.03);
                   }
                   //skapi.OutputLine( tryit +","+ MyLng );
                   skapi.OutputLine("heading = "+MyLoc.head);
                   skapi.OutputLine("MyLat "+MyLat+", MyLng "+MyLng);
                   //skapi.OutputLine( (MyLat - ((heading >= 110 && heading <= 250) ? (.03) : (-.03) )) +","+ MyLng );
                   //var tryit = (MyLat - (-.03));
                   //skapi.OutputLine("tryit = "+tryit);
                   //skapi.GoToMaploc( ( skapi.MaplocFromLatLng( MyLat, MyLng - ((heading >= 110 && heading <= 250) ? (.03) : (-.03) ))  ) , 0.001, true );
                   //var DoorMaploc = skapi.MaplocFromLatLng(DoorLat, DoorLng);
                   skapi.GoToMaploc((skapi.MaplocFromLatLng(DoorLat, DoorLng)), 0.001, true);
                   skapi.OutputLine("DoorMaploc "+DoorLat+","+ DoorLng);
                   
          skapi.WaitEvent(10000,wemSpecific,evidOnNavStop);
       }
      acf_Chest.distMax = distance_Chest;
      coaco_Chest = acf_Chest.CoacoGet();
      //aco_Chest = coaco_Chest.Item(0);
      oid_Chest = coaco_Chest.Item(0).oid;
      //skapi.OutputLine("Chest ACO: "+aco_Chest);
      skapi.OutputLine("Chest OID: "+oid_Chest);
      
      drop("Stamina Tincture");
      drop("Health Draught");
      drop("Realgar Pea");
      drop("Adept Healing Kit");
      while( moveItemToPack("Platinum Scarab",0,0,true) );  //itemName,packStart,packEnd,stackAllowed
      while( moveItemToPack("Pyreal",0,0,true) );
      relog(slotclapper);
      startvar();
   }else{
      acf_Chest.distMax = distance_Chest;
      coaco_Chest = acf_Chest.CoacoGet();
      //aco_Chest = coaco_Chest.Item(0);
      oid_Chest = coaco_Chest.Item(0).oid;
      //skapi.OutputLine("Chest ACO: "+aco_Chest);
      skapi.OutputLine("Chest OID: "+oid_Chest);
   }
      pickup("Stamina Tincture");
      //pickup("Health Draught");
      pickup("Realgar Pea");
      pickup("Adept Healing Kit");
}

function startvar() {
   EyeDropper = skapi.AcoFindInInv("Eye Dropper");
   Alembic = skapi.AcoFindInInv("Alembic");
   HealKitTotal = skapi.CitemOfKindInInv("Adept Healing Kit");
   PeaTotal = skapi.CitemOfKindInInv("Realgar Pea");
   DraughtTotal = skapi.CitemOfKindInInv("Health Draught");
   VictualTotal = skapi.CitemOfKindInInv("Victual Infusion");
   HealKit = skapi.AcoFindInInv("Adept Healing Kit");
   Pea = skapi.AcoFindInInv("Realgar Pea");
   Draught = skapi.AcoFindInInv("Health Draught");
   Victual = skapi.AcoFindInInv("Victual Infusion");
   ConcVictualTotal = skapi.CitemOfKindInInv("Concentrated Victual Infusion");
   ConcVictual = skapi.AcoFindInInv("Concentrated Victual Infusion");
   PotionTotal = skapi.CitemOfKindInInv("Potion of Healing");
   Potion = skapi.AcoFindInInv("Potion of Healing");
   StamTincture = skapi.AcoFindInInv("Stamina Tincture");
   StamTinctureTotal = skapi.CitemOfKindInInv("Stamina Tincture");
   merch = skapi.AcoFromSz("Brisin the Healer");
   mage = skapi.AcoFromSz("Sialla Jiro");
   char = skapi.szName;
}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////// HANDLERS ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

/*
function MyHandlers_OnChatServer(szMsg, cmc) {
   if(szMsg == "You brew a health potion.") {
      TotalPotions++;
      szEditMsg = "Potions Made: "+TotalPotions;
   skapi.SetControlProperty(szPanelName, "editMsg5", "Text", szEditMsg);
   }
}

function MyHandlers_OnLogon(acoChar)
{
 skapi.OutputLine("acoChar.oty = "+acoChar.oty);
 skapi.OutputLine("acoChar.oty & otyPK "+acoChar.oty & otyPK);
 skapi.OutputLine("acoChar.oty | otyPK "+acoChar.oty | otyPK);
 if(acoChar.oty & otyPK) {
    playerkiller = true;
    }else{
    playerkiller = false;
 }
 skapi.OutputLine("playerkiller = "+playerkiller);
}

function MyHandlers_OnSetFlagSelf(iflag, fOn)
{
 skapi.OutputLine("iflag "+iflag+", fOn "+fOn);
 if(fOn) {
    playerkiller = true;
    //gamestate = pk;
 }else{
    playerkiller = false;
    //pktimer.cmsec = 0;
    //gamestate = makespike;
 }
}


function MyHandlers_OnAssessItem(aco, fSuccess, ibi, iai, iwi, iei, ipi) {
   skapi.OutputLine("IDing "+aco.szName);
   itemAssess= {};
   itemAssess.aco= aco;
   itemAssess.fSuccess= fSuccess;
   itemAssess.ibi= ibi;
   itemAssess.iai= iai;
   itemAssess.iwi= iwi;
   itemAssess.iei= iei;
   itemAssess.ipi= ipi;
}
*/   

function MyHandlers_OnTellMisc(acoSender, acoReceiver, szMsg) {
   //sSay("OnTell: "+acoSender.szName+" told "+acoReceiver.szName+": "+szMsg);
   switch(szMsg.toLowerCase()) {
   case "status":
      Progress();
      fgetcurloc();
      skapi.Tell(acoSender.szName, "I have made "+PlatProgress+" Plats in "+Hours+" Hours "+Mins+ " Mins "+Seconds+" Seconds");
      delay(250);
      skapi.Tell(acoSender.szName, "For an average of "+PlatsPerHour+" Plats/HR || "+PlatsPerDay+" Plats/Day || "+MsPerHour+" MNote/HR || "+PyrealsPerHour+" Pyreals/HR");
      delay(250);
      skapi.Tell(acoSender.szName, "Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
      delay(250);
      skapi.Tell(acoSender.szName, "Gamestate: " + gamestate);
      delay(250);
      skapi.Tell(acoSender.szName, "Currntly running version number : "+VersionNo);
      break;
 
   default:
      break;
   }
}

function MyHandlers_OnCommand(szCmd) {
   switch (szCmd.toLowerCase()) {
      case "pause":
         gamestate = pause;
         break;
      case "resume":
         skapi.OutputLine("Resuming");
         gamestate = makepotion;
         break;
      case "status":
         Progress();
         skapi.OutputLine("I have made "+PlatProgress+" Plats in "+Hours+" Hours "+Mins+ " Mins "+Seconds+" Seconds");
         skapi.OutputLine("For an average of "+PlatsPerHour+" Plats/HR || "+PlatsPerDay+" Plats/Day || "+MsPerHour+" MNote/HR || "+PyrealsPerHour+" Pyreals/HR");
         skapi.OutputLine("Currntly running version number : "+VersionNo);
         break;
      case "buffchain":
         buffchain = true;
         skapi.OutputLine("Setting Var buffchain to true");
         Buff();
         break;
      case "nobuffchain":
         buffchain = false;
         skapi.OutputLine("Setting Var buffchain to false");
         break;
   }
}

function MyHandlers_OnApproachVendor(acoMerchant,mcmBuy,cpyMaxBuy,fractBuy,fractSell,coaco)
{
 Vendor= {};
 Vendor.aco= acoMerchant;        // Vendor object
 Vendor.buys= mcmBuy;            // Buy categories
 Vendor.max= cpyMaxBuy;          // Maximum buy price
 Vendor.buypct= fractBuy;        // The percent of list price paid
 Vendor.sellpct= fractSell;         // The selling markup
 Vendor.stock= coaco;            // List of vendor's stock
}

function MyHandlers_OnLeaveVendor(acoMerchant)
{
 Vendor= null;       // Remove vendor object
}

function MyHandlers_OnSpellAdd(spell) {
   if (spell.szName == buffbotlastspell) donebuffing = true;
   Autothreshold();
}

function MyHandlers_OnSpellExpire(spellid, layer) {
   Autothreshold();
}

function MyHandlers_OnEnd3D() {
   Progress();
   skapi.OutputLine("LOGGING OUT!!!");
   skapi.OutputLine("Run Time: "+Hours+" Hours "+Mins+ " Mins "+Seconds+" Seconds");
   skapi.OutputLine("I have made "+PlatProgress+" Plats in "+Hours+" Hours "+Mins+ " Mins "+Seconds+" Seconds");
   skapi.OutputLine("For an average of "+PlatsPerHour+" Plats/HR || "+PlatsPerDay+" Plats/Day || "+MsPerHour+" MNote/HR || "+PyrealsPerHour+" Pyreals/HR");
   skapi.OutputLine("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
   skapi.OutputLine("Gamestate: " + gamestate);
}

function myHandlers()
{
 this.OnTellMisc            = MyHandlers_OnTellMisc;
 //this.OnChatServer      = MyHandlers_OnChatServer;
 this.OnApproachVendor  = MyHandlers_OnApproachVendor;
 //this.OnControlEvent    = MyHandlers_OnControlEvent;
 //this.OnTimer           = MyHandlers_OnTimer;
 this.OnSpellAdd        = MyHandlers_OnSpellAdd;
 this.OnSpellExpire     = MyHandlers_OnSpellExpire;
 //this.OnAddToInventory  = MyHandlers_OnAddToInventory;
 this.OnCommand         = MyHandlers_OnCommand;
 this.OnEnd3D           = MyHandlers_OnEnd3D;
 this.OnLeaveVendor     = MyHandlers_OnLeaveVendor;
 //this.OnSetFlagSelf     = MyHandlers_OnSetFlagSelf;
 //this.OnLogon           = MyHandlers_OnLogon;
 //this.OnAssessItem      = MyHandlers_OnAssessItem;
}

function fAddHandlers()
{
 skapi.AddHandler(evidOnTellMisc             ,h);
 //skapi.AddHandler(evidOnChatServer           ,h);
 skapi.AddHandler(evidOnApproachVendor       ,h);
 //skapi.AddHandler(evidOnControlEvent         ,h);
 //skapi.AddHandler(evidOnTimer                ,h);
 skapi.AddHandler(evidOnSpellAdd             ,h);
 skapi.AddHandler(evidOnSpellExpire          ,h);
 //skapi.AddHandler(evidOnAddToInventory       ,h);
 skapi.AddHandler(evidOnCommand              ,h);
 skapi.AddHandler(evidOnEnd3D                ,h);
 skapi.AddHandler(evidOnLeaveVendor          ,h);
 //skapi.AddHandler(evidOnSetFlagSelf          ,h);
 //skapi.AddHandler(evidOnLogon                ,h);
 //skapi.AddHandler(evidOnAssessItem           ,h);
}

function fRemoveHandlers()
{
 skapi.RemoveHandler(evidOnTellMisc          ,h);
 //skapi.RemoveHandler(evidOnChatServer        ,h);
 skapi.RemoveHandler(evidOnApproachVendor    ,h);
 //skapi.RemoveHandler(evidOnControlEvent      ,h);
 //skapi.RemoveHandler(evidOnTimer             ,h);
 skapi.RemoveHandler(evidOnSpellAdd          ,h);
 skapi.RemoveHandler(evidOnSpellExpire       ,h);
 //skapi.RemoveHandler(evidOnAddToInventory    ,h);
 skapi.RemoveHandler(evidOnCommand           ,h);
 skapi.RemoveHandler(evidOnEnd3D             ,h);
 skapi.RemoveHandler(evidOnLeaveVendor       ,h);
 //skapi.RemoveHandler(evidOnSetFlagSelf       ,h);
 //skapi.RemoveHandler(evidOnLogon             ,h);
 //skapi.RemoveHandler(evidOnAssessItem        ,h);

}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////// MAKE POTION /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

function MakePotion() {
   //skapi.OutputLine("Making Potions");
   //for(var k=0; k<25; k++) {
      VictualTotal = skapi.CitemOfKindInInv("Victual Infusion");
      DraughtTotal = skapi.CitemOfKindInInv("Health Draught");
      HealKitTotal = skapi.CitemOfKindInInv("Adept Healing Kit");
      StamTinctureTotal = skapi.CitemOfKindInInv("Stamina Tincture");
      Victual = skapi.AcoFindInInv("Victual Infusion");
      Draught = skapi.AcoFindInInv("Health Draught");
      HealKit = skapi.AcoFindInInv("Adept Healing Kit");
      if(VictualTotal > 0 && DraughtTotal > 0 && HealKitTotal > 0) {
         if(skapi.healthCur <= HealthThreshold) {
            do {
               HealKit = skapi.AcoFindInInv("Adept Healing Kit");
               HealKit.UseOnAco(skapi.acoChar);
               while(fPointerBusy()) {delay(100);} //skapi.WaitEvent(2000,wemSpecific,evidOnVitals);  //evidOnVitals
               HealKitTotal = skapi.CitemOfKindInInv("Adept Healing Kit");
            } while(skapi.healthCur <= MaxHealth && HealKitTotal > 0);
         }
         if(skapi.staminaCur <= StaminaThreshold) {
            do {
               StamTincture = skapi.AcoFindInInv("Stamina Tincture");
               StamTincture.Use();
               while(fPointerBusy()) {delay(100);} //skapi.WaitEvent(2000,wemSpecific,evidOnVitals);  //evidOnVitals
               StamTinctureTotal = skapi.CitemOfKindInInv("Stamina Tincture");
            } while(skapi.staminaCur <= MaxStamina && StamTinctureTotal > 0);
         } 
         Victual.UseOnAco(Draught);
         while(fPointerBusy()) {delay(100);} //skapi.WaitEvent(2500,wemSpecific,evidOnAddToInventory);  //evidOnActionComplete
         delay(50);
         //Timer();
      }
   //}
   var acf_Potion = skapi.AcfNew();
   acf_Potion.szName = "Potion of Healing";
   acf_Potion.olc = olcInventory;
   acf_Potion.citemStackMax = 1;
   coaco_Potion = acf_Potion.CoacoGet();
   if(coaco_Potion.Count > 20) {
      while( moveItemToPack("Potion of Healing",0,0,true) );  //itemName,packStart,packEnd,stackAllowed
      //skapi.Keys(cmidCameraLower);
   }
}

function MakeVictual()  {
   //skapi.OutputLine("Making Victual Infusions");
   PeaTotal = skapi.CitemOfKindInInv("Realgar Pea");
   VictualTotal = skapi.CitemOfKindInInv("Victual Infusion");
   while(VictualTotal == 0 && PeaTotal > 0 ) {
      ConcVictualTotal = skapi.CitemOfKindInInv("Concentrated Victual Infusion");
      if(ConcVictualTotal == 0){
         Pea = skapi.AcoFindInInv("Realgar Pea");
         Alembic.UseOnAco(Pea);
         skapi.WaitEvent(2000,wemSpecific,evidOnRemoveFromInventory);
      }

      ConcVictualTotal = skapi.CitemOfKindInInv("Concentrated Victual Infusion");
      if(ConcVictualTotal > 0) {
         ConcVictual = skapi.AcoFindInInv("Concentrated Victual Infusion");
         EyeDropper.UseOnAco(ConcVictual);
         skapi.WaitEvent(2000,wemSpecific,evidOnRemoveFromInventory);
      }
      VictualTotal = skapi.CitemOfKindInInv("Victual Infusion");
      PeaTotal = skapi.CitemOfKindInInv("Realgar Pea");
   }
   if(PeaTotal == 0) gamestate = needitem;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////// LOCATION/NAVIGATION /////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

function fgetcurloc() {
   skapi.WaitEvent(1000,wemSpecific,evidOnLocChangeSelf);
   MyLoc = skapi.maplocCur;
   MyLat = MyLoc.lat.toFixed(3);
   MyLng = MyLoc.lng.toFixed(3);
   if(MyLat > 11.126 && MyLat < 11.326 && MyLng > 59.302 && MyLng < 59.502) {
      currentlocation = "Lifestone";
      skapi.outputline("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
      return;
   }
   if(MyLat > 10.681 && MyLat < 10.881 && MyLng > 58.337 && MyLng < 58.537) {
      currentlocation = "Healer";
      skapi.outputline("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
      return;
   }
   if(MyLat > -0.480 && MyLat < -0.373 && MyLng > 0.257 && MyLng < 0.287) {
      //Current Location: Unknown, MyLat: 10.670, MyLng: 58.308 is desired position right outside the retreat
      currentlocation = "Retreat";
      skapi.outputline("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
      return;
   }
   if(MyLat > -0.494 && MyLat < -0.450 && MyLng > 0.013 && MyLng < 0.031) {
      currentlocation = "Mage";
      skapi.outputline("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
      return;
   }
   if(MyLat >= (11.100 - .1) && MyLat <= (11.100 + .1) && MyLng >= (58.600 - .1) && MyLng <= (58.600 + .1)) {
      currentlocation = "Work";
      skapi.outputline("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
      return;
   }
   if(MyLat >= (15.200 - .1) && MyLat <= (15.200 + .1) && MyLng >= (-17.800 - .1) && MyLng <= (-17.800 + .1)) {
      currentlocation = "Slaughter House";
      skapi.outputline("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
      return;
   }
   currentlocation = "Unknown";
   skapi.outputline("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
   return;
}

/*
function fGoToWork() {
   skapi.outputline("Going to Work Location");
   skapi.MouseMove(0,0);
   skapi.MouseButton(ibuttonLeft);
   switch (currentlocation) {
      case "Healer":
         route.FromFile(g_baseDir + g_routes[4]);
         route.Go();
         break;
      case "Lifestone":
         route.FromFile(g_baseDir + g_routes[4]);
         route.Go();
         break;
      default:
         while(currentlocation != "Lifestone") {
            skapi.WaitEvent(3000,3);
            say("/lifestone");
            skapi.WaitEvent(60000,wemSpecific,evidOnEndPortalSelf);
            fgetcurloc();
         }
         route.FromFile(g_baseDir + g_routes[4]);
         route.Go();
         break;
   }
   fgetcurloc();
}
*/

function fGoToHealer() {
   skapi.outputline("Going to Healer");
   skapi.OutputLine("Run Time: "+Hours+" Hours "+Mins+ " Mins "+Seconds+" Seconds");
   skapi.MouseMove(0,0);
   skapi.MouseButton(ibuttonLeft);
   switch (currentlocation) {
      case "Healer":
         break;
      
      case "Lifestone":
         xroute.FromFile("lif-to-healer.xroute", false);
         e = ErrRunXroute(xroute);
         if (e) {
            skapi.OutputLine("Error caught: "+e);
            return;
         }
         break;
      
      default:
         while(currentlocation != "Lifestone") {
            say("@Lifestone");
            skapi.WaitEvent(60000,wemSpecific,evidOnEndPortalSelf);
            fgetcurloc();
         }
         xroute.FromFile("lif-to-healer.xroute", false);
         e = ErrRunXroute(xroute);
         if (e) {
            skapi.OutputLine("Error caught: "+e);
            return;
         }
         break;
   }
   fgetcurloc();
}

function fGoToRetreat() {
   skapi.outputline("Going to Retreat");
   skapi.MouseMove(0,0);
   skapi.MouseButton(ibuttonLeft);
   switch (currentlocation) {
      case "Retreat":
         break;
      
      case "Healer":
         xroute.FromFile("healer-to-portal.xroute", false);
         e = ErrRunXroute(xroute);
         if (e) {
            skapi.OutputLine("Error caught: "+e);
            return;
         }
         break;

      default:
         while(currentlocation != "Lifestone") {
            say("@Lifestone");
            skapi.WaitEvent(60000,wemSpecific,evidOnEndPortalSelf);
            fgetcurloc();
         }
         xroute.FromFile("lif-to-mage.xroute", false);
         e = ErrRunXroute(xroute);
         if (e) {
            skapi.OutputLine("Error caught: "+e);
            return;
         }
         break;
   }
   if(currentlocation != "Retreat") {
      RetreatPortal = skapi.AcoFromSZ("Martine's Retreat");
      RetreatPortal.use();
      skapi.WaitEvent(60000,wemSpecific,evidOnEndPortalSelf);
      delay(3000);
   }
   fgetcurloc();
}

function fGoToMage() {
   skapi.outputline("Going to Mage");
   skapi.MouseMove(0,0);
   skapi.MouseButton(ibuttonLeft);
   if(currentlocation == "Mage") {
      return;
   }
   if(currentlocation == "Retreat") {
      xroute.FromFile("portal-to-mage.xroute", false);
      //route.csecTimeout = 180
      e = ErrRunXroute(xroute);
      if (e) {
         skapi.OutputLine("Error caught: "+e);
         return;
      }
   }
   else {
      while(currentlocation != "Retreat") {
         fGoToRetreat();
         fgetcurloc();
      }
   }
   fgetcurloc(); 
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////// MOVING/STACKING//////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

function moveItemToPack(itemName,packStart,packEnd,stackAllowed) { // Packs range from 0-7
   skapi.WaitEvent(0);
   skapi.OutputLine("Moving "+itemName+" to pack range: "+packStart+"-"+packEnd+", items "+(stackAllowed ? "will" : "will not")+ " be stacked");
   //skapi.OutputLine((skapi.AcoFromSz(itemName).citemMaxStack)-1);
   if(skapi.AcoFindInInv(itemName)) {
      var short_acf = skapi.AcfNew();
      short_acf.szName = itemName;
      short_acf.olc = olcInventory;
      short_acf.citemStackMax = (skapi.AcoFromSz(itemName).citemMaxStack)-1; //99
      var shortCollection = short_acf.CoacoGet();
      //skapi.OutputLine("Collection of Plats less than 100 = " +shortCollection.Count);
      if(shortCollection.Count <= 1) {
         skapi.OutputLine("1 Moving FALSE");
         return false;
      }
      skapi.OutputLine("1 Moving TRUE");
      for (var i=0; i<shortCollection.Count-1; i++) {
         var shortStack = shortCollection.Item(i);
         var tempStack = shortCollection.Item(shortCollection.Count - 1);
         shortStack.MoveToStack(tempStack);
         skapi.WaitEvent(2500,wemSpecific,evidOnRemoveFromInventory);
         delay(100);
         //shortCollection = short_acf.CoacoGet();
      }
      shortCollection = short_acf.CoacoGet();
      if(shortCollection.Count <= 1) {
         skapi.OutputLine("2 Moving FALSE");
         return false;
         }else{
         skapi.OutputLine("2 Moving TRUE");
         return true;
      }
   }
   skapi.OutputLine("3 Moving FALSE");
   return false;
}

function OpenChest() { //function OpenChest(distance) {
   skapi.WaitEvent(0);
   aco_Chest = skapi.AcoFromOid(oid_Chest);
   skapi.OutputLine("Starting Function OpenChest");//, setting max range to: "+distance
   
   //acf_Chest.distMax = distance;
   //coaco_Chest = acf_Chest.CoacoGet();
   
   //skapi.OutputLine("Total 'Storage' Object(s) found : "+coaco_Chest.Count);
   //if(!coaco_Chest.Count) {return false;} // || coaco_Chest.Count >= 2
   
   //aco_Chest = coaco_Chest.Item(0);
   do {
      skapi.OutputLine("Assessing Chest");
      skapi.AssessAco(aco_Chest);
      skapi.WaitEvent(1000, wemSpecific, evidOnAssessItem);
   } while(!aco_Chest.oai); //while(skapi.WaitEvent(3000, wemSpecific, evidOnAssessItem) == evidOnAssessItem);
   skapi.OutputLine("Chest is "+((aco_Chest.oai.ibi.fOpen) ? "open" : "closed"));
   while(!aco_Chest.oai.ibi.fOpen) {
      aco_Chest.Use();
      skapi.WaitEvent(5000, wemSpecific, evidOnOpenContainer);
      skapi.AssessAco(aco_Chest);
      skapi.WaitEvent(3000, wemSpecific, evidOnAssessItem);
   }
   return true;
}

function drop(szItem) {
   skapi.WaitEvent(0);
   skapi.OutputLine("Droping "+szItem);
   while( moveItemToPack(szItem,0,0,true) );  //itemName,packStart,packEnd,stackAllowed
   
   while( !OpenChest() ); //while( !OpenChest(.05) );
   
   delay(1000);
   skapi.WaitEvent(0);
   
   var acf_Pack = skapi.AcfNew();
   acf_Pack.szName = "Pack";
   acf_Pack.oty = otyContainer;
   acf_Pack.olc = olcContained;
   var coaco_Pack = acf_Pack.CoacoGet();
   var aco_Pack = coaco_Pack.Item(0);
   
   var aco_Item = skapi.AcoFindInInv(szItem);
   i=0;
   while(aco_Item) {
      if(aco_Chest.citemContents < aco_Chest.citemMax) {
         aco_Item.MoveToContainer(aco_Chest,0,true);
         while(fPointerBusy()) {delay(100);} //skapi.WaitEvent(3000, wemSpecific, evidOnRemoveFromInventory);
      }else{
         if(aco_Pack.citemContents < aco_Pack.citemMax) {
            aco_Item.MoveToContainer(aco_Pack,0,true);
            while(fPointerBusy()) {delay(100);} //skapi.WaitEvent(3000, wemSpecific, evidOnRemoveFromInventory);
         }else{
            aco_Item.Drop();
            while(fPointerBusy()) {delay(100);} //skapi.WaitEvent(3000, wemSpecific, evidOnRemoveFromInventory);
         }
      }
      aco_Item = skapi.AcoFindInInv(szItem);
      //delay(1250);2
      i++;
      if(i>50) {
         while( !OpenChest() ); 
         i=0; 
      }
   }
   delay(1000);
   skapi.WaitEvent(0);
}

function pickup(szItem,Amount) { // Amount defaults to all
   skapi.WaitEvent(0);
   skapi.OutputLine("Picking up "+szItem);
   
   while( !OpenChest() );
   
   delay(1000);
   skapi.WaitEvent(0);
   
   var acf_Item = skapi.AcfNew();
   acf_Item.olc = olcContained;
   acf_Item.szName = szItem;
   var coaco_Item = acf_Item.CoacoGet();
   
   if(Amount) {
      for(var i=0; i<((coaco_Item.Count < Amount) ? coaco_Item.Count:Amount); i++) { //((coaco_Item.Count < Amount) ? coaco_Item.Count:Amount)
         var aco_Item = coaco_Item.Item(i);
         aco_Item.MoveToPack(0,0,true);
         while(fPointerBusy()) {delay(100);} //skapi.WaitEvent(5000, wemSpecific, evidOnAddToInventory);
         //delay(750);
      }
   }else{
      while(coaco_Item.count > 0) {
         var aco_Item = coaco_Item.Item(0);
         aco_Item.MoveToPack(0,0,true);
         while(fPointerBusy()) {delay(100);} //skapi.WaitEvent(5000, wemSpecific, evidOnAddToInventory);
         //delay(750);
         coaco_Item = acf_Item.CoacoGet();
      }
   }
   delay(1000);
   skapi.WaitEvent(0);
}
      
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////// VENDOR INTERACTION //////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

function fOpenVendor(VendorName,VendorItem) {
   //var loop=0;
   while(!Vendor) {
      skapi.MouseMove(0,0);
      skapi.MouseButton(ibuttonLeft);
      skapi.acoChar.Use();
      merch = skapi.AcoFromSz(VendorName);
      merch.Use();
      skapi.WaitEvent(7000, wemSpecific, evidOnApproachVendor);
      //loop++;
      //if(loop >= 3) {
      //   say("@Lifestone");
      //   skapi.WaitEvent(90000,wemSpecific,evidOnEndPortalSelf);
      //   return;
      //}
   }
   if(VendorItem != null) {
      itemaco = null;
      for(var i=0; i<Vendor.stock.count; i++) {
         var aco = Vendor.stock.Item(i);
         if(aco.szName == VendorItem) {
            itemaco = aco;
            return;
         }
      }
   }
}

function cFindList( listItem )
{
   var merchantCategory = new Array(18);
   //Initialize values
   for( var i = 0; i < merchantCategory.length; i++ )
   {
      merchantCategory[i] = false;
   }
   //Initialize what is present and what isn't
   var merchantMask = new Array(18);
   merchantMask[0] = mcmArmor; // Armor
   merchantMask[1] = mcmBooksPaper; // BooksPaper
   merchantMask[2] = mcmClothing; // Clothing
   merchantMask[3] = mcmContainers; // Containers
   merchantMask[4] = mcmFood; // Food
   merchantMask[5] = mcmGems; // Gems
   merchantMask[6] = mcmJewelry; // Jewelry
   merchantMask[7] = mcmKeysTools; // KeysTools
   merchantMask[8] = mcmCreature
                  | mcmPyreal
                  | mcmMisc
                  | mcmPortal
                  | mcmLockable
                  | mcmMiscFletching
                  | mcmPlants;      // Miscellaneous
   merchantMask[9] = mcmServices; // Services
   merchantMask[10] = mcmSpellComponents; // SpellComponents
   merchantMask[11] = mcmTradeNotes; // TradeNotes
   merchantMask[12] = mcmWeaponsMelee
                  | mcmWeaponsMissile;      // Weapons
   merchantMask[13] = mcmManaStones; // ManaStones
   merchantMask[14] = mcmMagicItems; // MagicItems
   merchantMask[15] = mcmAlchemicalItems1 // AlchemicalItems
                  | mcmAlchemicalItems2;
   merchantMask[16] = mcmCookingItems1 // CookingItems
                  | mcmCookingItems2;
   merchantMask[17] = mcmFletchingItems1
                  | mcmFletchingItems2;      // FletchingItems
   for( var i = 0; i < Vendor.stock.Count; i++ )
   {
      for( var j = 0; j < merchantMask.length; j++)
      {
         if ( Vendor.stock.Item(i).mcm & merchantMask[j])
         {
            merchantCategory[j] = true;
            break;
         }
      }
   }
   totalTab = 0;
   var theTab = 0;
   for( var i = 0; i < merchantCategory.length; i++ )
   {
      if( merchantCategory[i] == true )
      {
         totalTab++;
         if( merchantMask[i] & listItem.mcm )
            theTab = totalTab;
      }
   }
   skapi.OutputLine("theTab = "+theTab);
   return theTab;
}

function Buy(itemName,Price,Amount,Loc,VendorName) {
   skapi.OutputLine("Buying started for "+itemName);
   skapi.WaitEvent(0);
   var Loop = 0;
   var Loopmax;
   //var acf_ItemTotal = skapi.AcfNew();
   //acf_ItemTotal.szName = itemName;
   //var coaco_ItemTotal = acf_ItemTotal.CoacoGet(coaco_SlotClapper);
   //var ItemTotal = coaco_ItemTotal.Count;
   switch(itemName) {
      case "Health Draught":
         var ItemTotal = DraughtTotal;
         skapi.OutputLine("ItemTotal = "+ItemTotal);
         break;
      case "Adept Healing Kit":
         var ItemTotal = HealKitTotal;
         skapi.OutputLine("ItemTotal = "+ItemTotal);
         break;
      case "Stamina Tincture":
         var ItemTotal = StamTinctureTotal;
         skapi.OutputLine("ItemTotal = "+ItemTotal);
         break;
      case "Realgar Pea":
         var ItemTotal = PeaTotal;
         skapi.OutputLine("ItemTotal = "+ItemTotal);
         break;
      case "Platinum Scarab":
         var ItemTotal = 0;
         skapi.OutputLine("ItemTotal = "+ItemTotal);
         break;
   }
   var ItemLeft = Amount - ItemTotal;
   skapi.OutputLine("1 ItemLeft = "+ItemLeft);
   if(skapi.cpyCash < ItemLeft * Price) { ItemLeft = Math.floor(skapi.cpyCash / Price); }
   skapi.OutputLine("2 ItemLeft = "+ItemLeft);
   //if(skapi.cpyCash > (buyspike + buyhead) * Price) {
   //   var TempCalc = Math.floor(((skapi.cpyCash - ItemLeft * Price) % platprice) / Price);
   //   buyspike = buyspike + TempCalc;
   //}
   
   if(ItemLeft > 0) {
      skapi.OutputLine("Buying "+ItemLeft+" "+itemName+" for "+Price+" from "+VendorName+" at "+Loc);
      fgetcurloc();
      while(currentlocation != Loc) {
         if(Loc == "Healer") fGoToHealer();
         if(Loc == "Mage") fGoToMage();
         fgetcurloc();
      }
      fOpenVendor(VendorName,itemName);
      if(!Vendor) return false;
      var tab = cFindList( itemaco );
      skapi.MouseMove(50,-93 +chatwin);
      skapi.MouseButton(ibuttonLeft);     //Select Items
      delay(150);
      if(tab > 1) {
         skapi.MouseMove(112,-70 +chatwin);
         skapi.MouseButton(ibuttonLeft);     //Select Dropdown Menu
         delay(150);
         skapi.MouseMove(50,-50 +((tab-1)*18) +chatwin);
         //delay(5000);
         skapi.OutputLine("Moving Mouse to: 50, "+(-50 +((tab-1)*18) +chatwin));
         //cOpenMerchantList( tab );
         skapi.MouseButton(ibuttonLeft);     //Select Correct Catagory
         delay(150);
      }
      for(var z=0;z<5;z++) {
         skapi.OutputLine(z+" Selecting "+itemName);
         if(skapi.acoSelected != itemaco) { 
            skapi.SelectAco(itemaco); 
            delay(500);
            }else{
            break;
         }
         if(z==4) { return false; } 
      }
      if(ItemLeft >= itemaco.citemMaxStack) {
         skapi.Keys(cmidSplitSelected);     //Select Num box
         delay(150);
         skapi.Keys(itemaco.citemMaxStack);
         delay(150);
         skapi.MouseMove(-344,-38 +chatwin); //680,475
         delay(150);
         Loopmax = Math.floor(ItemLeft / itemaco.citemMaxStack);
         while(Loop != Loopmax) {
            skapi.MouseButton(ibuttonLeft);
            delay(150);
            Loop++;
          }
      } 
      var ItemLeftTemp = ItemLeft % itemaco.citemMaxStack;
      if(ItemLeftTemp > 0) {
         skapi.Keys(cmidSplitSelected);     //Select Num box
         delay(150);
         skapi.Keys(ItemLeftTemp);
         delay(150);
         skapi.MouseMove(-344,-38 +chatwin); //680,475
         delay(150);
         skapi.MouseButton(ibuttonLeft);
      }   
      delay(150);
      skapi.MouseMove(150,-93 +chatwin);
      skapi.MouseButton(ibuttonLeft);
      delay(150);
      skapi.MouseMove(-344,-38 +chatwin);
      skapi.MouseButton(ibuttonLeft);
      skapi.WaitEvent(10000,wemSpecific,evidOnAddToInventory);
      skapi.WaitEvent(0);
      delay(2000);
      ItemTotal = skapi.CitemOfKindInInv(itemName);
      skapi.OutputLine("ItemTotal = "+ItemTotal);
      //PeaTotal = skapi.CitemOfKindInInv("Realgar Pea");
      //DraughtTotal = skapi.CitemOfKindInInv("Health Draught");
      //HealKitTotal = skapi.CitemOfKindInInv("Adept Healing Kit");
      //StamTinctureTotal = skapi.CitemOfKindInInv("Stamina Tincture");
   }
   if(ItemTotal >= ItemLeft) {
      skapi.OutputLine("return true");
      return true;
      }else{
      skapi.OutputLine("return false");
      return false;
   }
}

function Sell(itemName,Loc,VendorName) {
   skapi.OutputLine("Selling started for "+itemName);
   skapi.WaitEvent(0);
   if(skapi.CitemOfKindInInv(itemName) > 0) {
      fgetcurloc();
      while(currentlocation != Loc) {
         if(Loc == "Healer") fGoToHealer();
         if(Loc == "Mage") fGoToMage();
         fgetcurloc();
      }
      fOpenVendor(VendorName,itemName);
      if(!Vendor) return false;
      delay(250);
      
      var acf_Item = skapi.AcfNew();
      acf_Item.szName = itemName;
      acf_Item.olc = olcInventory;
      var coaco_Item = acf_Item.CoacoGet();
      for(var i=0; i<coaco_Item.count; i++) {
         coaco_Item.Item(i).MoveToStack(merch); //merch from fOpenVendor
         delay(150);
      }
      skapi.MouseMove(-344,-38 +chatwin);
      skapi.MouseButton(ibuttonLeft);
      skapi.WaitEvent(10000,wemSpecific,evidOnRemoveFromInventory);
      skapi.WaitEvent(0);
      delay(2000);
      if(skapi.CitemOfKindInInv(itemName) != 0) {
         skapi.MouseMove(-319, -100 +chatwin);
         skapi.MouseButton(ibuttonLeft);
         delay(1000);
         skapi.MouseMove(-219, -125);
         skapi.MouseButton(ibuttonLeft);
         skapi.WaitEvent(10000, wemSpecific, evidOnLeaveVendor);
         return false;
      }
   }
   if(skapi.CitemOfKindInInv(itemName) == 0) {
      return true;
   }else{
      return false;
   }
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////// MAIN LOOP ///////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

function main() {
// skapi.ShowControls(szSchema, true);
 skapi.SetIdleTime(2592000); // 30*24*60*60 = 2592000 = 30days
 fAddHandlers();
 gamestate = makepotion;
 timer = skapi.TimerNew();
 bufftimer = skapi.TimerNew();
 logtimer = skapi.TimerNew();
 PlatsAtStart = skapi.CitemOfKindInInv("Platinum Scarab");
 PyrealStart = skapi.cpyCash;
 chatwin = -1 * (66 + (skapi.dypRes / 4));  //-258
 //skapi.OutputLine("dypRes " + skapi.dypRes + " chatwin " + chatwin);
 /*
 bufftimer.cmsec = 3300000;
 var TempSpellCo, TempSpell;
 TempSpellCo = new Enumerator(skapi.cospell);
 for(; !TempSpellCo.atEnd(); TempSpellCo.moveNext()) {
    TempSpell = TempSpellCo.item();
    if(TempSpell.szName == buffbotlastspell) bufftimer.cmsec = (TempSpell.csecElapsed * 1000);
 }
 */
 for(var l=0; l<skapi.cchar; l++) {
    var slot = skapi.rgszChar(l);
    if(slot.match(/Half/)) slotclapper = l;
    if(slot.match(/Total/)) slotrunner = l;
 }
 skapi.MouseMove(-318,-90);      //706,678
 skapi.MouseButton(ibuttonLeft); //Chat Maximize
 skapi.WaitEvent(150,3);
 skapi.OutputLine("Currently running version number : "+VersionNo, opmChatWnd | opmConsole, cmcRed);
 skapi.OutputLine("skapi.cchar " +skapi.cchar+ " slotclapper " +slotclapper+ " slotrunner " +slotrunner);
 //skapi.OutputLine("Minutes left until rebuff: " +((3300000 - bufftimer.cmsec) / 1000 / 60));
 startup();
 Autothreshold();
 fgetcurloc();
 while(1) {
    switch (gamestate) {
       case makepotion:
          //skapi.OutputLine("gamestate = makepotion");
          skapi.WaitEvent(0);
          //Progress();
          if(logtimer.cmsec >= 43200000 && RestartScript == true) { //12 hours 1000 * 60 * 60 * 12 = 43200000
             restart();
             logtimer.cmsec = 0;
          }
          if(VictualTotal == 0)    { MakeVictual(); }
          if(HealKitTotal == 0)    { gamestate = needitem; }
          if(StamTinctureTotal == 0) { gamestate = needitem; }
          if(DraughtTotal == 0) {
             skapi.OutputLine("pickup(Health Draught,1);");
             pickup("Health Draught",1);
             
             acf_Item.szName = "Health Draught";
             var coaco_Item = acf_Item.CoacoGet();
             if(skapi.CitemOfKindInInv("Health Draught") == 0 && coaco_Item.Count == 0) {
                gamestate = needitem;
             }
             //delay(2000);
             drop("Potion of Healing");
          }
          MakePotion();
          break;
       case needitem:
          skapi.OutputLine("gamestate = needitem");
          skapi.WaitEvent(0);
          
          Progress();
          drop("Potion of Healing");
          //var acf_SlotClapper = skapi.AcfNew();
          //acf_SlotClapper.olc = olcInventory;
          //coaco_SlotClapper = acf_SlotClapper.CoacoGet();
          
          acf_Item.szName = "Health Draught";
          var coaco_Item = acf_Item.CoacoGet();
          DraughtTotal = skapi.CitemOfKindInInv("Health Draught")+(coaco_Item.Count*100);
          skapi.OutputLine("DraughtTotal "+DraughtTotal);
          
          
          acf_Item.szName = "Adept Healing Kit";
          var coaco_Item = acf_Item.CoacoGet();
          HealKitTotal = skapi.CitemOfKindInInv("Adept Healing Kit")+(coaco_Item.Count);
          skapi.OutputLine("HealKitTotal "+HealKitTotal);
          
          
          //acf_Item.szName = "Stamina Tincture";
          //var coaco_Item = acf_Item.CoacoGet();
          StamTinctureTotal = skapi.CitemOfKindInInv("Stamina Tincture");
          skapi.OutputLine("StamTinctureTotal "+StamTinctureTotal);
          
          
          //acf_Item.szName = "Realgar Pea";
          //var coaco_Item = acf_Item.CoacoGet();
          PeaTotal = skapi.CitemOfKindInInv("Realgar Pea");
          skapi.OutputLine("PeaTotal "+PeaTotal);
          
          relog(slotrunner);
          pickup("Potion of Healing");
          
          Pauser.Clear();
          suicide();
          Pauser.Clear();
          
          PlatsAtStart = skapi.CitemOfKindInInv("Platinum Scarab");
          while(! Sell("Potion of Healing","Healer","Brisin the Healer") );  //Item,Loc,VendorName
          
          while(! Buy("Adept Healing Kit",68,30,"Healer","Brisin the Healer") ); //30//Item,Price,Amount,Loc,VendorName
          while(! Buy("Stamina Tincture",135,30,"Healer","Brisin the Healer") ); //30
          while(! Buy("Health Draught",115,1000,"Healer","Brisin the Healer") ); //1000
          while(! Buy("Realgar Pea",844,50,"Mage","Sialla Jiro") ); //50
          while(! Buy("Platinum Scarab",54000,100,"Mage","Sialla Jiro") ); //100
          PlatsNow = skapi.CitemOfKindInInv("Platinum Scarab");
          for(z=PlatsNow-PlatsAtStart;z>0;z--) {
             PlatsTotal = PlatsTotal+1
          }
          
          do {
             say("@House Recall");
             skapi.WaitEvent(90000,wemSpecific,evidOnEndPortalSelf);
             skapi.WaitEvent(0);
             delay(5000);
             skapi.OutputLine("skapi.acoChar.maploc.head = "+skapi.maplocCur.head);
             var heading = skapi.maplocCur.head;
             fgetcurloc();
             skapi.outputline("Current Location: " + currentlocation + ", MyLat: " + MyLat + ", MyLng: " + MyLng);
          } while(skapi.maplocCur.dungid == 22112 || skapi.maplocCur.dungid == 0);
          var acf_Door = skapi.AcfNew();
          acf_Door.szName = "Door";
          acf_Door.distMax = .03;
          var coaco_Door = acf_Door.CoacoGet();
          var aco_Door= coaco_Door.Item(0);     // Try to find object
          skapi.OutputLine("Door ACO is "+aco_Door.oid);
          var mloc= aco_Door.maploc;         // Get the location
          var l=0;
          do {
             skapi.GoToMaploc(mloc,0.002,true); // Walk to door
             skapi.WaitEvent(9000,wemSpecific,evidOnNavStop);
             do {
                skapi.OutputLine("Assessing Door");
                skapi.AssessAco(aco_Door);
                skapi.WaitEvent(1000, wemSpecific, evidOnAssessItem);
             } while(!aco_Door.oai); //while(skapi.WaitEvent(3000, wemSpecific, evidOnAssessItem) == evidOnAssessItem);
             skapi.OutputLine("Door is "+((aco_Door.oai.ibi.fOpen) ? "open" : "closed"));
             while(!aco_Door.oai.ibi.fOpen) {
                aco_Door.Use();
                skapi.WaitEvent(5000, wemSpecific, evidOnOpenContainer);
                skapi.AssessAco(aco_Door);
                skapi.WaitEvent(3000, wemSpecific, evidOnAssessItem);
             }
             l++;
             if(l>10) {
                say("@House Recall");
                skapi.WaitEvent(90000,wemSpecific,evidOnEndPortalSelf);
                skapi.WaitEvent(0);
                delay(5000);
                l=0;
             }
             /*
             skapi.AssessAco(aco_Door);      // Force an object assess
             skapi.WaitEvent(3000,wemSpecific,evidOnAssessItem); // Wait for completion
             while(aco_Door.oai && !aco_Door.oai.ibi.fOpen) { // Open?
                aco_Door.Use();              // Use it
                skapi.WaitEvent(5000,wemSpecific,evidOnActionComplete);
                skapi.AssessAco(aco_Door);      // Force an object assess
                skapi.WaitEvent(3000,wemSpecific,evidOnAssessItem); // Wait for completion
             }
             */
          } while(skapi.maplocCur.Dist2DToMaploc(mloc)>0.002); // Repeat?
          
          MyLoc = skapi.maplocCur;
          MyLat = MyLoc.lat.toFixed(3);
          MyLng = MyLoc.lng.toFixed(3);
          var heading = MyLoc.head;
          var DoorLat = MyLat;
          var DoorLng = MyLng;
          ///////
          if(heading >= 330 || heading <= 50) { //North 0
             var DoorLat = MyLat - (-0.03);
          }
          ///////
          if(heading >= 130 && heading <= 230) { //South 180
             var DoorLat = MyLat - (0.03);
          }
          ////////
          if(heading >= 60 && heading <= 120) { //East 90
             var DoorLng = MyLng - (-0.03);
          }
          ////////
          if(heading >= 240 && heading <= 320) { // West 270
             var DoorLng = MyLng - (0.03);
          }
          skapi.OutputLine("heading = "+MyLoc.head);
          skapi.OutputLine("MyLat "+MyLat+", MyLng "+MyLng);
          skapi.GoToMaploc((skapi.MaplocFromLatLng(DoorLat, DoorLng)), 0.001, true);
          skapi.OutputLine("DoorMaploc "+DoorLat+","+ DoorLng);
          
          skapi.WaitEvent(10000,wemSpecific,evidOnNavStop);
          drop("Stamina Tincture");
          drop("Health Draught");
          drop("Realgar Pea");
          drop("Adept Healing Kit");
          while( moveItemToPack("Platinum Scarab",0,0,true) );  //itemName,packStart,packEnd,stackAllowed
          while( moveItemToPack("Pyreal",0,0,true) );
          relog(slotclapper);
          pickup("Stamina Tincture");
          //pickup("Health Draught");
          pickup("Realgar Pea");
          pickup("Adept Healing Kit");
          Autothreshold();
          
          gamestate = makepotion;
          break;
       case pause:
          skapi.WaitEvent(0);
          Progress();
          skapi.OutputLine("Paused");
          while(gamestate == pause) {
             skapi.WaitEvent(1000,3);
             Progress();
          }
          break;
       default:
          skapi.OutputLine("Default!");
          gamestate = makepotion;
          break;
    }
 }
}